Index: trunk/src/VBox/Additions/x11/VBoxClient/clipboard.h
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/clipboard.h	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/clipboard.h	(revision 27709)
@@ -95,5 +95,5 @@
     int init(void)
     {
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         int rc = mThreadFunction.init();
         if (RT_SUCCESS(rc))
@@ -101,5 +101,5 @@
         if (RT_SUCCESS(rc))
             mInit = true;
-        LogFlowThisFunc(("returning %Rrc\n", rc));
+        LogRelFlowFunc(("returning %Rrc\n", rc));
         return rc;
     }
@@ -110,8 +110,8 @@
     void uninit(RTMSINTERVAL cMillies = RT_INDEFINITE_WAIT)
     {
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         if (mInit)
             mThread.stop(cMillies, NULL);
-        LogFlowThisFunc(("returning\n"));
+        LogRelFlowFunc(("returning\n"));
     }
 
@@ -121,10 +121,10 @@
     ~VBoxGuestClipboard()
     {
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         if (mInit)
             try {
                 uninit(2000);
             } catch (...) { }
-        LogFlowThisFunc(("returning\n"));
+        LogRelFlowFunc(("returning\n"));
     }
 };
Index: trunk/src/VBox/Additions/x11/VBoxClient/display.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/display.cpp	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/display.cpp	(revision 27709)
@@ -45,5 +45,5 @@
     uint32_t fMouseFeatures = 0;
 
-    LogFlowFunc(("testing dynamic resizing\n"));
+    LogRelFlowFunc(("testing dynamic resizing\n"));
     int iDummy;
     if (!XRRQueryExtension(pDisplay, &iDummy, &iDummy))
@@ -55,7 +55,7 @@
     /* Log and ignore the return value, as there is not much we can do with
      * it. */
-    LogFlowFunc(("dynamic resizing: result %Rrc\n", rc));
+    LogRelFlowFunc(("dynamic resizing: result %Rrc\n", rc));
     /* Enable support for switching between hardware and software cursors */
-    LogFlowFunc(("enabling relative mouse re-capturing support\n"));
+    LogRelFlowFunc(("enabling relative mouse re-capturing support\n"));
     rc = VbglR3GetMouseStatus(&fMouseFeatures, NULL, NULL);
     if (RT_SUCCESS(rc))
@@ -79,5 +79,5 @@
                              | VMMDEV_MOUSE_GUEST_NEEDS_HOST_CURSOR);
     }
-    LogFlowFunc(("mouse re-capturing support: result %Rrc\n", rc));
+    LogRelFlowFunc(("mouse re-capturing support: result %Rrc\n", rc));
     return VINF_SUCCESS;
 }
@@ -86,5 +86,5 @@
 {
     uint32_t fMouseFeatures = 0;
-    LogFlowFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     VbglR3CtlFilterMask(0,   VMMDEV_EVENT_DISPLAY_CHANGE_REQUEST
                            | VMMDEV_EVENT_MOUSE_CAPABILITIES_CHANGED);
@@ -93,5 +93,5 @@
         VbglR3SetMouseStatus(  fMouseFeatures
                              | VMMDEV_MOUSE_GUEST_NEEDS_HOST_CURSOR);
-    LogFlowFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -119,5 +119,5 @@
     pConfig = XRRGetScreenInfo(pDisplay, DefaultRootWindow(pDisplay));
     /* Reset the current mode */
-    LogFlowFunc(("Setting size %ux%u\n", cx, cy));
+    LogRelFlowFunc(("Setting size %ux%u\n", cx, cy));
     if (pConfig)
     {
@@ -130,5 +130,5 @@
             unsigned uThisDist =   VBCL_SQUARE(pSizes[i].width - cx)
                                  + VBCL_SQUARE(pSizes[i].height - cy);
-            LogFlowFunc(("Found size %dx%d, distance %u\n", pSizes[i].width,
+            LogRelFlowFunc(("Found size %dx%d, distance %u\n", pSizes[i].width,
                          pSizes[i].height, uThisDist));
 #undef VBCL_SQUARE
@@ -143,5 +143,5 @@
             Time config_timestamp = 0;
             XRRConfigTimes(pConfig, &config_timestamp);
-            LogFlowFunc(("Setting new size %d\n", iMode));
+            LogRelFlowFunc(("Setting new size %d\n", iMode));
             XRRSetScreenConfig(pDisplay, pConfig,
                                DefaultRootWindow(pDisplay), iMode,
@@ -161,5 +161,5 @@
 static int runDisplay(Display *pDisplay)
 {
-    LogFlowFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     Cursor hClockCursor = XCreateFontCursor(pDisplay, XC_watch);
     Cursor hArrowCursor = XCreateFontCursor(pDisplay, XC_left_ptr);
@@ -199,5 +199,5 @@
         }
     }
-    LogFlowFunc(("returning VINF_SUCCESS\n"));
+    LogRelFlowFunc(("returning VINF_SUCCESS\n"));
     return VINF_SUCCESS;
 }
Index: trunk/src/VBox/Additions/x11/VBoxClient/hostversion.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/hostversion.cpp	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/hostversion.cpp	(revision 27709)
@@ -52,5 +52,5 @@
         if (conn == NULL)
         {
-            LogFlow(("Could not retrieve D-BUS session bus!\n"));
+            LogRelFlowFunc(("Could not retrieve D-BUS session bus!\n"));
             rc = VERR_INVALID_HANDLE;
         }
@@ -63,5 +63,5 @@
             if (msg == NULL)
             {
-                Log(("Could not create D-BUS message!\n"));
+                LogRel(("Could not create D-BUS message!\n"));
                 rc = VERR_INVALID_HANDLE;
             }
@@ -109,5 +109,5 @@
             if (dbus_error_is_set(&err))
             {
-                Log(("D-BUS returned an error while sending the notification: %s", err.message));
+                LogRel(("D-BUS returned an error while sending the notification: %s", err.message));
             }
             else if (reply)
@@ -133,5 +133,5 @@
     {
         int rc;
-        LogFlowFunc(("\n"));
+        LogRelFlowFunc(("\n"));
 
         /* Because we need desktop notifications to be displayed, wait
@@ -154,5 +154,5 @@
             rc = VbglR3GuestPropConnect(&uGuestPropSvcClientID);
             if (RT_FAILURE(rc))
-                Log(("Cannot connect to guest property service! rc = %Rrc\n", rc));
+                LogRel(("Cannot connect to guest property service! rc = %Rrc\n", rc));
         }
 
@@ -179,5 +179,5 @@
                     LogRel(("VBoxClient: VirtualBox Guest Additions update available!"));
                     if (RT_FAILURE(rc))
-                        Log(("VBoxClient: Could not show version notifier tooltip! rc = %d\n", rc));
+                        LogRel(("VBoxClient: Could not show version notifier tooltip! rc = %d\n", rc));
                 }
 
@@ -191,5 +191,5 @@
         }
 # endif /* VBOX_WITH_GUEST_PROPS */
-        LogFlowFunc(("returning %Rrc\n", rc));
+        LogRelFlowFunc(("returning %Rrc\n", rc));
         return rc;
     }
Index: trunk/src/VBox/Additions/x11/VBoxClient/main.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/main.cpp	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/main.cpp	(revision 27709)
@@ -42,5 +42,5 @@
 #include "VBoxClient.h"
 
-#define TRACE RTPrintf("%s: %d\n", __PRETTY_FUNCTION__, __LINE__); Log(("%s: %d\n", __PRETTY_FUNCTION__, __LINE__))
+#define TRACE RTPrintf("%s: %d\n", __PRETTY_FUNCTION__, __LINE__); LogRel(("%s: %d\n", __PRETTY_FUNCTION__, __LINE__))
 
 static int (*gpfnOldIOErrorHandler)(Display *) = NULL;
@@ -76,5 +76,5 @@
 void vboxClientSignalHandler(int cSignal)
 {
-    Log(("VBoxClient: terminated with signal %d\n", cSignal));
+    LogRel(("VBoxClient: terminated with signal %d\n", cSignal));
     /** Disable seamless mode */
     RTPrintf(("VBoxClient: terminating...\n"));
@@ -100,5 +100,5 @@
 static int vboxClientXLibIOErrorHandler(Display *pDisplay)
 {
-    Log(("VBoxClient: a fatal guest X Window error occurred.  This may just mean that the Window system was shut down while the client was still running.\n"));
+    LogRel(("VBoxClient: a fatal guest X Window error occurred.  This may just mean that the Window system was shut down while the client was still running.\n"));
     VBoxClient::CleanUp();
     return 0;  /* We should never reach this. */
@@ -113,5 +113,5 @@
     struct sigaction sigAction;
 
-    LogFlowFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     sigAction.sa_handler = vboxClientSignalHandler;
     sigemptyset(&sigAction.sa_mask);
@@ -126,5 +126,5 @@
     sigaction(SIGUSR1, &sigAction, NULL);
     sigaction(SIGUSR2, &sigAction, NULL);
-    LogFlowFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -224,5 +224,5 @@
         {
             RTPrintf("VBoxClient: failed to daemonize.  Exiting.\n");
-            Log(("VBoxClient: failed to daemonize.  Exiting.\n"));
+            LogRel(("VBoxClient: failed to daemonize.  Exiting.\n"));
 # ifdef DEBUG
             RTPrintf("Error %Rrc\n", rc);
@@ -237,5 +237,5 @@
     {
         RTPrintf("VBoxClient: failed to get home directory, rc=%Rrc.  Exiting.\n", rc);
-        Log(("VBoxClient: failed to get home directory, rc=%Rrc.  Exiting.\n", rc));
+        LogRel(("VBoxClient: failed to get home directory, rc=%Rrc.  Exiting.\n", rc));
         return 1;
     }
@@ -244,5 +244,5 @@
     {
         RTPrintf("VBoxClient: RTPathAppend failed with rc=%Rrc.  Exiting.\n", rc);
-        Log(("VBoxClient: RTPathAppend failed with rc=%Rrc.  Exiting.\n", rc));
+        LogRel(("VBoxClient: RTPathAppend failed with rc=%Rrc.  Exiting.\n", rc));
         return 1;
     }
@@ -252,5 +252,5 @@
     {
         RTPrintf("Failed to connect to the VirtualBox kernel service\n");
-        Log(("Failed to connect to the VirtualBox kernel service\n"));
+        LogRel(("Failed to connect to the VirtualBox kernel service\n"));
         return 1;
     }
@@ -258,5 +258,5 @@
     {
         RTPrintf("Failed to create a pidfile.  Exiting.\n");
-        Log(("Failed to create a pidfile.  Exiting.\n"));
+        LogRel(("Failed to create a pidfile.  Exiting.\n"));
         VbglR3Term();
         return 1;
Index: trunk/src/VBox/Additions/x11/VBoxClient/seamless-host.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/seamless-host.cpp	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/seamless-host.cpp	(revision 27709)
@@ -38,5 +38,5 @@
     int rc = VERR_NOT_SUPPORTED;
 
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     if (mRunning)  /* Assertion */
     {
@@ -52,5 +52,5 @@
     if (RT_SUCCESS(rc))
     {
-        Log(("VBoxClient: enabled seamless capability on host.\n"));
+        LogRel(("VBoxClient: enabled seamless capability on host.\n"));
         rc = mThread.start();
         if (RT_SUCCESS(rc))
@@ -66,7 +66,7 @@
     if (RT_FAILURE(rc))
     {
-        Log(("VBoxClient (seamless): failed to enable seamless capability on host, rc=%Rrc\n", rc));
+        LogRel(("VBoxClient (seamless): failed to enable seamless capability on host, rc=%Rrc\n", rc));
     }
-    LogFlowThisFunc(("returning %Rrc\n", rc));
+    LogRelFlowFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -75,5 +75,5 @@
 void VBoxGuestSeamlessHost::stop(RTMSINTERVAL cMillies /* = RT_INDEFINITE_WAIT */)
 {
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
     if (!mRunning)  /* Assertion */
     {
@@ -85,5 +85,5 @@
     VbglR3SeamlessSetCap(false);
     mRunning = false;
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -97,5 +97,5 @@
     VMMDevSeamlessMode newMode = VMMDev_Seamless_Disabled;
 
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     int rc = VbglR3SeamlessWaitEvent(&newMode);
     if (RT_SUCCESS(rc))
@@ -129,7 +129,7 @@
     else
     {
-        LogFunc(("VbglR3SeamlessWaitEvent returned %Rrc (VBoxClient)\n", rc));
+        LogRelFunc(("VbglR3SeamlessWaitEvent returned %Rrc (VBoxClient)\n", rc));
     }
-    LogFlowThisFunc(("returning %Rrc\n", rc));
+    LogRelFlowFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -140,5 +140,5 @@
 void VBoxGuestSeamlessHost::updateRects(std::auto_ptr<std::vector<RTRECT> > pRects)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     if (0 == pRects.get())  /* Assertion */
     {
@@ -147,5 +147,5 @@
     }
     VbglR3SeamlessSendRects(pRects.get()->size(), pRects.get()->empty() ? NULL : &pRects.get()->front());
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -158,5 +158,5 @@
 int VBoxGuestSeamlessHostThread::threadFunction(VBoxGuestThread *pThread)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     if (0 != mHost)
     {
@@ -172,5 +172,5 @@
         }
     }
-    LogFlowThisFunc(("returning VINF_SUCCESS\n"));
+    LogRelFlowFunc(("returning VINF_SUCCESS\n"));
     return VINF_SUCCESS;
 }
@@ -181,5 +181,5 @@
 void VBoxGuestSeamlessHostThread::stop(void)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     if (0 != mHost)
     {
@@ -196,4 +196,4 @@
         }
     }
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
Index: trunk/src/VBox/Additions/x11/VBoxClient/seamless-host.h
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/seamless-host.h	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/seamless-host.h	(revision 27709)
@@ -126,5 +126,5 @@
     int init(VBoxGuestSeamlessObserver *pObserver)
     {
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         if (mObserver != 0)  /* Assertion */
         {
@@ -133,5 +133,5 @@
         }
         mObserver = pObserver;
-        LogFlowThisFunc(("returning VINF_SUCCESS\n"));
+        LogRelFlowFunc(("returning VINF_SUCCESS\n"));
         return VINF_SUCCESS;
     }
@@ -168,5 +168,5 @@
     ~VBoxGuestSeamlessHost()
     {
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         if (mRunning)  /* Assertion */
         {
@@ -178,5 +178,5 @@
             catch(...) {}
         }
-        LogFlowThisFunc(("returning\n"));
+        LogRelFlowFunc(("returning\n"));
     }
 };
Index: trunk/src/VBox/Additions/x11/VBoxClient/seamless-x11.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/seamless-x11.cpp	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/seamless-x11.cpp	(revision 27709)
@@ -46,5 +46,5 @@
                                     const char *aPropName, unsigned long *nItems)
 {
-    LogFlowFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     Atom propNameAtom = XInternAtom (aDpy, aPropName,
                                      True /* only_if_exists */);
@@ -65,5 +65,5 @@
         return NULL;
 
-    LogFlowFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
     return propVal;
 }
@@ -78,5 +78,5 @@
     int rc = VINF_SUCCESS;
 
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     if (0 != mObserver)  /* Assertion */
     {
@@ -90,5 +90,5 @@
     }
     mObserver = pObserver;
-    LogFlowThisFunc(("returning %Rrc\n", rc));
+    LogRelFlowFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -108,10 +108,10 @@
     int error, event;
 
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     mSupportsShape = XShapeQueryExtension(mDisplay, &event, &error);
     mEnabled = true;
     monitorClientList();
     rebuildWindowTree();
-    LogFlowThisFunc(("returning %Rrc\n", rc));
+    LogRelFlowFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -121,14 +121,14 @@
 void VBoxGuestSeamlessX11::stop(void)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     mEnabled = false;
     unmonitorClientList();
     freeWindowTree();
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
 void VBoxGuestSeamlessX11::monitorClientList(void)
 {
-    LogFlowThisFunc(("called\n"));
+    LogRelFlowFunc(("called\n"));
     XSelectInput(mDisplay, DefaultRootWindow(mDisplay.get()), SubstructureNotifyMask);
 }
@@ -136,5 +136,5 @@
 void VBoxGuestSeamlessX11::unmonitorClientList(void)
 {
-    LogFlowThisFunc(("called\n"));
+    LogRelFlowFunc(("called\n"));
     XSelectInput(mDisplay, DefaultRootWindow(mDisplay.get()), 0);
 }
@@ -146,5 +146,5 @@
 void VBoxGuestSeamlessX11::rebuildWindowTree(void)
 {
-    LogFlowThisFunc(("called\n"));
+    LogRelFlowFunc(("called\n"));
     freeWindowTree();
     addClients(DefaultRootWindow(mDisplay.get()));
@@ -170,5 +170,5 @@
     unsigned cChildren;
 
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     if (!XQueryTree(mDisplay.get(), hRoot, &hRealRoot, &hParent, &phChildrenRaw, &cChildren))
         return;
@@ -176,5 +176,5 @@
     for (unsigned i = 0; i < cChildren; ++i)
         addClientWindow(phChildren.get()[i]);
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -182,5 +182,5 @@
 void VBoxGuestSeamlessX11::addClientWindow(const Window hWin)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     XWindowAttributes winAttrib;
     bool fAddWin = true;
@@ -202,5 +202,5 @@
                                        &dummyLong)))
     {
-        LogFlowFunc(("window %lu, client window %lu has no size hints\n",
+        LogRelFlowFunc(("window %lu, client window %lu has no size hints\n",
                      hWin, hClient));
         fAddWin = false;
@@ -212,5 +212,5 @@
         bool hasShape = false;
 
-        LogFlowFunc(("adding window %lu, client window %lu\n", hWin,
+        LogRelFlowFunc(("adding window %lu, client window %lu\n", hWin,
                      hClient));
         if (mSupportsShape)
@@ -234,5 +234,5 @@
                                 winAttrib.width, winAttrib.height, cRects, rects);
     }
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -250,5 +250,5 @@
     bool rc = false;
 
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     windowTypeRaw = XXGetProperty(mDisplay, hWin, XA_ATOM, WM_TYPE_PROP, &ulCount);
     if (windowTypeRaw != NULL)
@@ -259,5 +259,5 @@
             rc = true;
     }
-    LogFlowThisFunc(("returning %s\n", rc ? "true" : "false"));
+    LogRelFlowFunc(("returning %s\n", rc ? "true" : "false"));
     return rc;
 }
@@ -270,5 +270,5 @@
 {
     /* We use post-increment in the operation to prevent the iterator from being invalidated. */
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     for (VBoxGuestWindowList::iterator it = mGuestWindows.begin(); it != mGuestWindows.end();
                  mGuestWindows.removeWindow(it++))
@@ -276,5 +276,5 @@
         XShapeSelectInput(mDisplay, it->first, 0);
     }
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -289,5 +289,5 @@
     XEvent event;
 
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     /* Start by sending information about the current window setup to the host.  We do this
        here because we want to send all such information from a single thread. */
@@ -314,5 +314,5 @@
         break;
     }
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -324,5 +324,5 @@
 void VBoxGuestSeamlessX11::doConfigureEvent(Window hWin)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     VBoxGuestWindowList::iterator iter;
 
@@ -352,5 +352,5 @@
         mChanged = true;
     }
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -362,5 +362,5 @@
 void VBoxGuestSeamlessX11::doMapEvent(Window hWin)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     VBoxGuestWindowList::iterator iter;
 
@@ -371,5 +371,5 @@
         mChanged = true;
     }
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -382,5 +382,5 @@
 void VBoxGuestSeamlessX11::doShapeEvent(Window hWin)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     VBoxGuestWindowList::iterator iter;
 
@@ -400,5 +400,5 @@
         mChanged = true;
     }
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -410,5 +410,5 @@
 void VBoxGuestSeamlessX11::doUnmapEvent(Window hWin)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     VBoxGuestWindowList::iterator iter;
 
@@ -419,5 +419,5 @@
         mChanged = true;
     }
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -427,5 +427,5 @@
 std::auto_ptr<std::vector<RTRECT> > VBoxGuestSeamlessX11::getRects(void)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     unsigned cRects = 0;
     std::auto_ptr<std::vector<RTRECT> > apRects(new std::vector<RTRECT>);
@@ -471,5 +471,5 @@
     }
     mcRects = cRects;
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
     return apRects;
 }
@@ -484,5 +484,5 @@
     bool rc = false;
 
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     /* Message contents set to zero. */
     XClientMessageEvent clientMessage = { ClientMessage, 0, 0, 0, 0, 0, 8 };
@@ -494,5 +494,5 @@
         rc = true;
     }
-    LogFlowThisFunc(("returning %s\n", rc ? "true" : "false"));
+    LogRelFlowFunc(("returning %s\n", rc ? "true" : "false"));
     return rc;
 }
Index: trunk/src/VBox/Additions/x11/VBoxClient/seamless-x11.h
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/seamless-x11.h	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/seamless-x11.h	(revision 27709)
@@ -146,7 +146,7 @@
     bool init(char *name = NULL)
     {
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         mDisplay = XOpenDisplay(name);
-        LogFlowThisFunc(("returning\n"));
+        LogRelFlowFunc(("returning\n"));
         return (mDisplay != NULL);
     }
@@ -156,8 +156,8 @@
     int close(void)
     {
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         int rc = XCloseDisplay(mDisplay);
         mDisplay = NULL;
-        LogFlowThisFunc(("returning\n"));
+        LogRelFlowFunc(("returning\n"));
         return rc;
     }
@@ -244,14 +244,14 @@
                    VBoxGuestX11Pointer<XRectangle> rects)
     {
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         VBoxGuestWinInfo *pInfo = new VBoxGuestWinInfo(isMapped, x, y, w, h, cRects,
                                                        rects);
         mWindows.insert(std::pair<Window, VBoxGuestWinInfo *>(hWin, pInfo));
-        LogFlowThisFunc(("returning\n"));
+        LogRelFlowFunc(("returning\n"));
     }
 
     void removeWindow(iterator it)
     {
-        LogFlowThisFunc(("called\n"));
+        LogRelFlowFunc(("called\n"));
         delete it->second;
         mWindows.erase(it);
@@ -260,5 +260,5 @@
     void removeWindow(Window hWin)
     {
-        LogFlowThisFunc(("called\n"));
+        LogRelFlowFunc(("called\n"));
         removeWindow(find(hWin));
     }
Index: trunk/src/VBox/Additions/x11/VBoxClient/seamless.h
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/seamless.h	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/seamless.h	(revision 27709)
@@ -59,5 +59,5 @@
         int rc = VINF_SUCCESS;
 
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         rc = mGuest->start();
         if (RT_SUCCESS(rc))
@@ -69,5 +69,5 @@
             mGuest->stop();
         }
-        LogFlowThisFunc(("returning %Rrc\n", rc));
+        LogRelFlowFunc(("returning %Rrc\n", rc));
         return rc;
     }
@@ -148,5 +148,5 @@
         int rc = VINF_SUCCESS;
 
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         if (isInitialised)  /* Assertion */
         {
@@ -172,7 +172,7 @@
         if (RT_FAILURE(rc))
         {
-            LogFunc(("returning %Rrc (VBoxClient)\n", rc));
-        }
-        LogFlowThisFunc(("returning %Rrc\n", rc));
+            LogRelFunc(("returning %Rrc (VBoxClient)\n", rc));
+        }
+        LogRelFlowFunc(("returning %Rrc\n", rc));
         return rc;
     }
@@ -180,5 +180,5 @@
     void uninit(RTMSINTERVAL cMillies = RT_INDEFINITE_WAIT)
     {
-        LogFlowThisFunc(("\n"));
+        LogRelFlowFunc(("\n"));
         if (isInitialised)
         {
@@ -188,5 +188,5 @@
             isInitialised = false;
         }
-        LogFlowThisFunc(("returning\n"));
+        LogRelFlowFunc(("returning\n"));
     }
 
Index: trunk/src/VBox/Additions/x11/VBoxClient/thread.cpp
===================================================================
--- trunk/src/VBox/Additions/x11/VBoxClient/thread.cpp	(revision 27601)
+++ trunk/src/VBox/Additions/x11/VBoxClient/thread.cpp	(revision 27709)
@@ -30,5 +30,5 @@
     int rc = VINF_SUCCESS;
 
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     if (NIL_RTTHREAD == mSelf)  /* Assertion */
     {
@@ -50,5 +50,5 @@
         }
     }
-    LogFlowThisFunc(("returning %Rrc\n", rc));
+    LogRelFlowFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -57,5 +57,5 @@
 VBoxGuestThread::~VBoxGuestThread(void)
 {
-    LogFlowThisFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     if (NIL_RTTHREAD != mSelf)
     {
@@ -67,5 +67,5 @@
         catch(...) {}
     }
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
 }
 
@@ -75,5 +75,5 @@
     int rc = VINF_SUCCESS;
 
-    LogFlowThisFunc(("returning\n"));
+    LogRelFlowFunc(("returning\n"));
     if (NIL_RTTHREAD != mSelf)  /* Assertion */
     {
@@ -84,5 +84,5 @@
     rc = RTThreadCreate(&mSelf, threadFunction, reinterpret_cast<void *>(this),
                           mStack, mType, mFlags, mName);
-    LogFlowThisFunc(("returning %Rrc\n", rc));
+    LogRelFlowFunc(("returning %Rrc\n", rc));
     return rc;
 }
@@ -99,5 +99,5 @@
     int rc = VINF_SUCCESS;
 
-    LogFlowFunc(("\n"));
+    LogRelFlowFunc(("\n"));
     PSELF pSelf = reinterpret_cast<PSELF>(pvUser);
     pSelf->mRunning = true;
@@ -117,5 +117,5 @@
     }
     pSelf->mRunning = false;
-    LogFlowFunc(("returning %Rrc\n", rc));
+    LogRelFlowFunc(("returning %Rrc\n", rc));
     return rc;
 }