Index: trunk/src/VBox/Main/MachineImpl.cpp
===================================================================
--- trunk/src/VBox/Main/MachineImpl.cpp	(revision 27831)
+++ trunk/src/VBox/Main/MachineImpl.cpp	(revision 27834)
@@ -3789,5 +3789,5 @@
  * Look up a guest property in VBoxSVC's internal structures.
  */
-HRESULT Machine::GetGuestPropertyFromService(IN_BSTR aName,
+HRESULT Machine::getGuestPropertyFromService(IN_BSTR aName,
                                              BSTR *aValue,
                                              ULONG64 *aTimestamp,
@@ -3822,5 +3822,5 @@
  *          VBoxSVC.
  */
-HRESULT Machine::GetGuestPropertyFromVM(IN_BSTR aName,
+HRESULT Machine::getGuestPropertyFromVM(IN_BSTR aName,
                                         BSTR *aValue,
                                         ULONG64 *aTimestamp,
@@ -3860,8 +3860,8 @@
     if (FAILED(autoCaller.rc())) return autoCaller.rc();
 
-    HRESULT rc = GetGuestPropertyFromVM(aName, aValue, aTimestamp, aFlags);
+    HRESULT rc = getGuestPropertyFromVM(aName, aValue, aTimestamp, aFlags);
     if (rc == E_ACCESSDENIED)
         /* The VM is not running or the service is not (yet) accessible */
-        rc = GetGuestPropertyFromService(aName, aValue, aTimestamp, aFlags);
+        rc = getGuestPropertyFromService(aName, aValue, aTimestamp, aFlags);
     return rc;
 #endif // VBOX_WITH_GUEST_PROPS
@@ -3886,5 +3886,5 @@
  * Set a guest property in VBoxSVC's internal structures.
  */
-HRESULT Machine::SetGuestPropertyToService(IN_BSTR aName, IN_BSTR aValue,
+HRESULT Machine::setGuestPropertyToService(IN_BSTR aName, IN_BSTR aValue,
                                            IN_BSTR aFlags)
 {
@@ -3988,5 +3988,5 @@
  *          VBoxSVC.
  */
-HRESULT Machine::SetGuestPropertyToVM(IN_BSTR aName, IN_BSTR aValue,
+HRESULT Machine::setGuestPropertyToVM(IN_BSTR aName, IN_BSTR aValue,
                                       IN_BSTR aFlags)
 {
@@ -4030,8 +4030,8 @@
     if (FAILED(autoCaller.rc())) return autoCaller.rc();
 
-    HRESULT rc = SetGuestPropertyToVM(aName, aValue, aFlags);
+    HRESULT rc = setGuestPropertyToVM(aName, aValue, aFlags);
     if (rc == E_ACCESSDENIED)
         /* The VM is not running or the service is not (yet) accessible */
-        rc = SetGuestPropertyToService(aName, aValue, aFlags);
+        rc = setGuestPropertyToService(aName, aValue, aFlags);
     return rc;
 #endif // VBOX_WITH_GUEST_PROPS
@@ -4047,5 +4047,5 @@
  * Enumerate the guest properties in VBoxSVC's internal structures.
  */
-HRESULT Machine::EnumerateGuestPropertiesInService
+HRESULT Machine::enumerateGuestPropertiesInService
                 (IN_BSTR aPatterns, ComSafeArrayOut(BSTR, aNames),
                  ComSafeArrayOut(BSTR, aValues),
@@ -4107,5 +4107,5 @@
  *          VBoxSVC.
  */
-HRESULT Machine::EnumerateGuestPropertiesOnVM
+HRESULT Machine::enumerateGuestPropertiesOnVM
                 (IN_BSTR aPatterns, ComSafeArrayOut(BSTR, aNames),
                  ComSafeArrayOut(BSTR, aValues),
@@ -4149,5 +4149,5 @@
     if (FAILED(autoCaller.rc())) return autoCaller.rc();
 
-    HRESULT rc = EnumerateGuestPropertiesOnVM
+    HRESULT rc = enumerateGuestPropertiesOnVM
                      (aPatterns, ComSafeArrayOutArg(aNames),
                       ComSafeArrayOutArg(aValues),
@@ -4156,5 +4156,5 @@
     if (rc == E_ACCESSDENIED)
         /* The VM is not running or the service is not (yet) accessible */
-        rc = EnumerateGuestPropertiesInService
+        rc = enumerateGuestPropertiesInService
                      (aPatterns, ComSafeArrayOutArg(aNames),
                       ComSafeArrayOutArg(aValues),
Index: trunk/src/VBox/Main/include/MachineImpl.h
===================================================================
--- trunk/src/VBox/Main/include/MachineImpl.h	(revision 27831)
+++ trunk/src/VBox/Main/include/MachineImpl.h	(revision 27834)
@@ -772,18 +772,18 @@
 
 #ifdef VBOX_WITH_GUEST_PROPS
-    HRESULT GetGuestPropertyFromService(IN_BSTR aName, BSTR *aValue,
+    HRESULT getGuestPropertyFromService(IN_BSTR aName, BSTR *aValue,
                                         ULONG64 *aTimestamp, BSTR *aFlags);
-    HRESULT GetGuestPropertyFromVM(IN_BSTR aName, BSTR *aValue,
+    HRESULT getGuestPropertyFromVM(IN_BSTR aName, BSTR *aValue,
                                    ULONG64 *aTimestamp, BSTR *aFlags);
-    HRESULT SetGuestPropertyToService(IN_BSTR aName, IN_BSTR aValue,
+    HRESULT setGuestPropertyToService(IN_BSTR aName, IN_BSTR aValue,
                                       IN_BSTR aFlags);
-    HRESULT SetGuestPropertyToVM(IN_BSTR aName, IN_BSTR aValue,
+    HRESULT setGuestPropertyToVM(IN_BSTR aName, IN_BSTR aValue,
                                  IN_BSTR aFlags);
-    HRESULT EnumerateGuestPropertiesInService
+    HRESULT enumerateGuestPropertiesInService
                 (IN_BSTR aPatterns, ComSafeArrayOut(BSTR, aNames),
                  ComSafeArrayOut(BSTR, aValues),
                  ComSafeArrayOut(ULONG64, aTimestamps),
                  ComSafeArrayOut(BSTR, aFlags));
-    HRESULT EnumerateGuestPropertiesOnVM
+    HRESULT enumerateGuestPropertiesOnVM
                 (IN_BSTR aPatterns, ComSafeArrayOut(BSTR, aNames),
                  ComSafeArrayOut(BSTR, aValues),