Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestCtrl.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestCtrl.cpp	(revision 27975)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageGuestCtrl.cpp	(revision 27976)
@@ -112,5 +112,5 @@
                 usageOK = false;
             else
-            {                
+            {
                 char **papszArg;
                 int cArgs;
@@ -119,9 +119,9 @@
                 if (RT_SUCCESS(rc))
                 {
-                    for (int a = 0; a < cArgs; a++)                       
+                    for (int a = 0; a < cArgs; a++)
                         env.push_back(Bstr(papszArg[a]));
 
                     RTGetOptArgvFree(papszArg);
-                }                
+                }
                 ++i;
             }
@@ -168,5 +168,5 @@
         else
         {
-            return errorSyntax(USAGE_GUESTCONTROL, 
+            return errorSyntax(USAGE_GUESTCONTROL,
                                "Invalid parameter '%s'", Utf8Str(a->argv[i]).raw());
         }
@@ -180,5 +180,5 @@
         &&  Utf8UserName.isEmpty())
     {
-        return errorSyntax(USAGE_GUESTCONTROL, 
+        return errorSyntax(USAGE_GUESTCONTROL,
                            "No user name for password specified!");
     }
@@ -199,15 +199,15 @@
             Bstr uuid;
             machine->COMGETTER(Id)(uuid.asOutParam());
-    
+
             /* open an existing session for VM - so the VM has to be running */
             CHECK_ERROR_BREAK(a->virtualBox, OpenExistingSession(a->session, uuid));
-    
+
             /* get the mutable session machine */
             a->session->COMGETTER(Machine)(machine.asOutParam());
-    
+
             /* get the associated console */
             ComPtr<IConsole> console;
             CHECK_ERROR_BREAK(a->session, COMGETTER(Console)(console.asOutParam()));
-    
+
             ComPtr<IGuest> guest;
             CHECK_ERROR_BREAK(console, COMGETTER(Guest)(guest.asOutParam()));
@@ -215,6 +215,6 @@
             ComPtr<IProgress> progress;
             ULONG uPID = 0;
-            CHECK_ERROR_BREAK(guest, ExecuteProgram(Bstr(Utf8Cmd), uFlags, 
-                                                    Bstr(Utf8Args), ComSafeArrayAsInParam(env), 
+            CHECK_ERROR_BREAK(guest, ExecuteProgram(Bstr(Utf8Cmd), uFlags,
+                                                    Bstr(Utf8Args), ComSafeArrayAsInParam(env),
                                                     Bstr(Utf8StdIn), Bstr(Utf8StdOut), Bstr(Utf8StdErr),
                                                     Bstr(Utf8UserName), Bstr(Utf8Password), uTimeoutMS,
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 27975)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageModifyVM.cpp	(revision 27976)
@@ -1273,5 +1273,5 @@
                 char *strTcpSnd;
                 char *strTcpRcv;
-                char *strRaw = RTStrDup(ValueUnion.psz); 
+                char *strRaw = RTStrDup(ValueUnion.psz);
                 char *ch = strRaw;
                 strMtu = ch;
@@ -1313,5 +1313,5 @@
                     char *strGuestIp;
                     char *strGuestPort;
-                    char *strRaw = RTStrDup(ValueUnion.psz); 
+                    char *strRaw = RTStrDup(ValueUnion.psz);
                     char *ch = strRaw;
                     strName = ch;
@@ -1323,5 +1323,5 @@
                     strHostPort = ch;
                     ITERATE_TO_NEXT_TERM(ch);
-                    strGuestIp = ch;                
+                    strGuestIp = ch;
                     ITERATE_TO_NEXT_TERM(ch);
                     strGuestPort = ch;
@@ -1337,5 +1337,5 @@
                         break;
                     }
-                    CHECK_ERROR(driver, AddRedirect(Bstr(strName), proto, Bstr(strHostIp), 
+                    CHECK_ERROR(driver, AddRedirect(Bstr(strName), proto, Bstr(strHostIp),
                             RTStrToUInt16(strHostPort), Bstr(strGuestIp), RTStrToUInt16(strGuestPort)));
                 }
@@ -1352,5 +1352,5 @@
             }
             #undef ITERATE_TO_NEXT_TERM
-            
+
             case MODIFYVM_NATTFTPPREFIX:
             {